/*
 * B1950toJ2000.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.app;

import java.io.*;
import java.util.*;
import misao.util.*;

public class B1950toJ2000 {
    public static void main ( String[] args ) throws Exception {
	System.out.println("Convert R.A. in B1950 into J2000.");

	DataInputStream din = new DataInputStream(System.in);

	System.out.println("Input positions: ");
	System.out.println("  ex. R.A.= 12h 4m31.2s  Decl.= - 0o15'");
	System.out.println("  acceptable style: 12 4 31.2 -0 15 0");
	System.out.print("Position (B1950.0): ");
	String pos_str = din.readLine();

	Coor coor = Coor.createCoor(pos_str);
	coor.precession(new JulianDay(Astro.BESSELL_1950), new JulianDay(Astro.JULIUS_2000));

	System.out.println("Position (J2000.0): " + coor.toStringRA() + " " + coor.toStringDecl());
    }
}
