/*
 * FITSHeadLine.java
 *
 * Copyright (C) 1998-2000 Taichi Kato
 *
 * Original package is jp.ac.kyoto-u.kusastro.ooruri.
 *
 */

package misao.contrib.imdisp;

import java.io.*;

public class FITSHeadLine {
	private byte buf[];
	private String str;
	private String item;
	private String value;
	
	FITSHeadLine(DataInput ds) {
		buf = new byte[80];
		try {
			ds.readFully(buf,0,80);
			str = new String(buf,0,80);
			init();
		}
		catch (IOException e) {
			System.out.println("Exception: " + e.toString());
		}
	}

	FITSHeadLine(String s) {
		int len = s.length();
		if (len == 0) {
			item = "";
			value ="";
			return;
		}
		if (s.charAt(len-1) == '\n')
			s = s.substring(0,len-1);
		str = s + "                                                                              ";
		init();
	}

	public String item() {
		return item;
	}
	
	public String value() {
		return value;
	}
	
	public boolean isEnd() {
		if (item.equals("END"))
			return true;
		else
			return false;
	}
	
	public String toString() {
		return item + "=" + value;
	}

	private void init() {
		item = _item();
		value = _value();
	}
		
	private String _item() {
		String tmp = str.substring(0,8);
		return tmp.trim();
	}
	
	private String _value() {
		int index = str.indexOf('/');
		if (index < 0)
			index = 40;
		String tmp = str.substring(9,index);
		tmp = tmp.trim();
		int start = 0;
		int end = tmp.length();
		if (end < 1)
			return "";
		if (tmp.charAt(0) == '\'')
			start = 1;
		if (tmp.charAt(end-1) == '\'')
			end--;
		if (end <= 0)
			return "";
		return tmp.substring(start,end);
	}
}
