/*
 * DifferentialImageInformation.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.diff;

import java.awt.*;
import java.io.*;
import java.net.*;
import misao.util.*;
import misao.pixy.*;

public class DifferentialImageInformation implements Printable {
    public String image_url1;
    public String image_url2;
    public Size image_size1;
    public Size image_size2;
    public Position pos_error;
    public MagError mag_error;
    public double limiting_mag;
    public double faintest_mag;
    public double overlap_ratio;

    public DifferentialImageInformation ( ) {
	image_url1 = "";
	image_url2 = "";
	image_size1 = new Size();
	image_size2 = new Size();
	pos_error = new Position(0,0);
	mag_error = new MagError(0.0);
	limiting_mag = 20.0;
	faintest_mag = 20.0;
	overlap_ratio = 0.0;
    }

    public void print ( PrintStream ps ) {
	new Parameter("image1", image_url1).print(ps);
	new Parameter("image2", image_url2).print(ps);
	new Parameter("image_size1", "" + image_size1.getWidth() + " x " + image_size1.getHeight()).print(ps);
	new Parameter("image_size2", "" + image_size2.getWidth() + " x " + image_size2.getHeight()).print(ps);
	new Parameter("limiting_mag", Astro.toString(limiting_mag, 5, 2).trim() + " mag").print(ps);
	new Parameter("faintest_mag", Astro.toString(faintest_mag, 5, 2).trim() + " mag").print(ps);
	new Parameter("pos_error", Astro.toString(pos_error.getX(), 8, 5).trim() + ", " + Astro.toString(pos_error.getY(), 8, 5).trim() + " pixels").print(ps);
	new Parameter("mag_error", mag_error.toString()).print(ps);
	new Parameter("overlap_ratio", Astro.toString(overlap_ratio, 4, 1).trim()).print(ps);
    }
}
