/*
 * MisaoProperty.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.host;

import java.io.*;
import java.util.*;
import misao.util.*;

public class MisaoProperty {
    public static String getHome ( ) {
	Properties properties = System.getProperties();
	String home = properties.getProperty("misao.home");
	if (home == null)
	    return "/misao";
	else
	    return home;
    }

    public static String getReferencePath ( ) {
	return getHome() + "/reference";
    }

    public static String getObsPath ( ) {
	return getHome() + "/obs";
    }

    public static String getDbvsPath ( ) {
	return getHome() + "/DBVS";
    }

    public static String getImageInformationListPath ( ) {
	return getHome() + "/image_information.list";
    }

    public static void createHome ( ) {
	File directory = new File(getHome());
	if (! directory.isDirectory())
	    directory.mkdir();
    }

    public static void createReferenceDirectory ( ) {
	createHome();
	File directory = new File(getReferencePath());
	if (! directory.isDirectory())
	    directory.mkdir();
    }

    public static void createObsDirectory ( ) {
	createHome();
	File directory = new File(getObsPath());
	if (! directory.isDirectory())
	    directory.mkdir();
    }

    public static void createDbvsDirectory ( ) {
	createHome();
	File directory = new File(getDbvsPath());
	if (! directory.isDirectory())
	    directory.mkdir();
    }
}
