/*
 * ReferenceData.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.host;

import misao.pixy.*;
import misao.util.*;

public class ReferenceData {
    private String name;
    private String dbvs_name;
    private Coor coor;
    private String record;

    private double pos_error;	// in arcsec

    private ReferenceType type;

    public ReferenceData ( String n, String dn, Coor cr, String s ) {
	name = n;
	dbvs_name = dn;
	coor = cr;
	record = s;
	pos_error = 1.0;
	type = null;
    }

    public ReferenceData ( String n, String dn, Coor cr, String s, double err, ReferenceType t ) {
	name = n;
	dbvs_name = dn;
	coor = cr;
	record = s;
	pos_error = err;
	type = t;
    }

    public void setType ( ReferenceType t ) {
	type = t;
    }

    public void setPositionError ( double pos_err ) {
	pos_error = pos_err;
    }

    public String getName ( ) {
	return name;
    }

    public String getDbvsName ( ) {
	return dbvs_name;
    }

    public Coor getCoor ( ) {
	return coor;
    }

    public ReferenceType getType ( ) {
	return type;
    }

    public double getPositionError ( ) {
	return pos_error;
    }

    public String getRecord ( ) {
	return record;
    }

    public String toString ( ) {
	return name + "\t" + dbvs_name + "\t" + coor.getRA() + "\t" + coor.getDecl();
    }
}
