/*
 * MatchingList.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import misao.util.*;

public class MatchingList {
    private StarList list1;
    private StarList list2;
    private double d_mag;

    private int index0;
    private int index1;
    private int index2;

    MatchingList ( StarList l1, StarList l2, double dm ) {
	list1 = l1;
	list2 = l2;

	d_mag = dm;
    }

    public TriStars findFirstTriStars ( TriStars tri ) {
	index0 = 0;
	index1 = 1;
	index2 = 2;

	return findNextTriStars(tri);
    }

    public TriStars findNextTriStars ( TriStars tri ) {
	TriStars t = null;
	if (index0 >= list2.size()  ||  index1 >= list2.size()  ||  index2 >= list2.size())
	    return null;

	while (t == null) {
	    if (Math.abs(tri.element(0).getMag() - list2.elementAt(index0).getMag()) < d_mag  &&
		Math.abs(tri.element(1).getMag() - list2.elementAt(index1).getMag()) < d_mag  &&
		Math.abs(tri.element(2).getMag() - list2.elementAt(index2).getMag()) < d_mag)
		t = new TriStars(list2.elementAt(index0), list2.elementAt(index1), list2.elementAt(index2));

	    index2++;
	    if (index2 >= list2.size()) {
		index1++;
		index2 = index1 + 1;
		if (index1 >= list2.size() - 1) {
		    index0++;
		    index1 = index0 + 1;
		    index2 = index1 + 1;
		    if (index0 >= list2.size() - 2)
			return t;
		}
	    }
	}

	return t;
    }
}
