/*
 * PixyOutputData.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import java.awt.*;
import java.io.*;
import java.net.*;
import misao.util.*;

public class PixyOutputData implements PixyOutputDataInterface {
    public ImagePixy image;
    public ImageInformation image_info;
    public PairList pair_list;
    public MapFunction map_function;

    public PixyOutputData ( ) {
	image = null;
	image_info = new ImageInformation();
	pair_list = new PairList();
	map_function = new MapFunction();
    }

    public void saveImage ( String filename ) throws Exception {
	if (image == null)
	    throw new Exception();

	MinMaxAverage mma = new ImageFileFits(image).getBestMinMax();

	ImageFilePgm pgm = new ImageFilePgm(new ImageGray(image.getSize()));
	Point pt = new Point(0, 0);
	for (pt.y = 0 ; pt.y < image.getHeight() ; pt.y++) {
	    for (pt.x = 0 ; pt.x < image.getWidth() ; pt.x++) {
		int p = (int)((image.getValue(pt) - mma.getMin()) / (mma.getMax() - mma.getMin()) * 256);
		if (p < 0)
		    p = 0;
		if (p > 255)
		    p = 255;
		pgm.setValue(pt, (double)p);
	    }
	}
	pgm.save(new File(filename));
    }
}
