/*
 * TriStarsForm.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import misao.util.*;

public class TriStarsForm extends Position {
    public TriStarsForm ( TriStars tri ) throws Exception {
	StarData star1 = tri.element(0);
	StarData star2 = tri.element(1);
	StarData star3 = tri.element(2);

	double r1 = Math.sqrt((star1.getX() - star2.getX()) * (star1.getX() - star2.getX()) + (star1.getY() - star2.getY()) * (star1.getY() - star2.getY()));
	double r2 = Math.sqrt((star2.getX() - star3.getX()) * (star2.getX() - star3.getX()) + (star2.getY() - star3.getY()) * (star2.getY() - star3.getY()));
	double r3 = Math.sqrt((star3.getX() - star1.getX()) * (star3.getX() - star1.getX()) + (star3.getY() - star1.getY()) * (star3.getY() - star1.getY()));

	if (r2 < r1) {
	    double swap = r2; r2 = r1; r1 = swap;
	}
	if (r3 < r2) {
	    double swap = r3; r3 = r2; r2 = swap;
	}
	if (r2 < r1) {
	    double swap = r2; r2 = r1; r1 = swap;
	}

	if (r1 < 0.00001) {
	    throw new Exception();
	}
	    
	setX(r2 / r1);
	setY(r3 / r2);
    }

    public double getRatio1 ( ) {
	return getX();
    }

    public double getRatio2 ( ) {
	return getY();
    }
}
