/*
 * BnV.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
Star    Position (J2000.0)   Con  Max.   Min.   Type  Identification
BnV1   01 03 06.0 +71 54 57  Cas  13.0r  16. v  SR?   -
BnV3   19 08 54.3 +22 03 36  Vul  15.1r  20. v  M     IRAS 19067+2158
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class BnV extends ReferenceCatalog {
    public BnV ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 54  ||  ! record.substring(0,3).equals("BnV"))
	    return null;

	String name = record.substring(0,6).trim();
	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Coor.createCoor(record.substring(7, 27)));

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
