/*
 * HadV.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
Code        R.A. (J2000.0) Decl.  Max    Min   Type    ID               
------------------------------------------------------------------------
new HadV01  174643.91 -180241.4  12.0p <14.5p  M       USNO0675.14316454
new HadV02  055053.70 +030729.5  11.5p  12.6p  M       GSC0120.0876
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class HadV extends ReferenceCatalog {
    private String discoverer;

    public HadV ( ) {
	discoverer = "";
    }

    public HadV ( String _discoverer ) {
	discoverer = _discoverer;
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 4  ||  ! record.substring(0,4).equals("new "))
	    return null;

	StringTokenizer st = new StringTokenizer(record);
	String s = st.nextToken();	// "new"
	String name = st.nextToken();
	String ra = st.nextToken();
	String decl = st.nextToken();
	String max = st.nextToken();
	String min = st.nextToken();
	String type = st.nextToken();
	String id = "";
	if (st.hasMoreTokens()) {
	    id = st.nextToken();
	    while (st.hasMoreTokens())
		id = id + "  " + st.nextToken();
	}

	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Integer.parseInt(ra.substring(0,2)), Integer.parseInt(ra.substring(2,4)), Double.valueOf(ra.substring(4)).doubleValue(), (decl.charAt(0) == '-'), Integer.parseInt(decl.substring(1,3)), Integer.parseInt(decl.substring(3,5)), Double.valueOf(decl.substring(5)).doubleValue());

	String decl_ss = "";
	if (decl.length() > 7)
	    decl_ss = decl.substring(7);

	s = name + "  R.A.=" + ra.substring(0,2) + "h" + ra.substring(2,4) + "m" + ra.substring(4,6) + "s" + ra.substring(6) + "  Decl.=" + decl.substring(0,3) + "o" + decl.substring(3,5) + "'" + decl.substring(5,7) + "\"" + decl_ss + "  Mag.: " + max + " - " + min + "  Type: " + type;
	if (discoverer.length() > 0)
	    s += "  " + discoverer;
	if (id.length() > 0)
	    s += "  " + id;

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, s);

	return data;
    }
}
