/*
 * NgcIc.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
IC   1	binary star	0008.4	+2743	-	-
IC   5	galaxy	0017.4	-0933	0.8	14p
NGC   1	galaxy	0007.3	+2743	1.9	13p
NGC7826	(none)	0005.2	-2044	-	-
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class NgcIc extends ReferenceCatalog {
    public NgcIc ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	StringTokenizer st = new StringTokenizer(record, "\t");
	String name = st.nextToken();
	String dbvs_name = name;
	if (name.substring(0, 2).equals("IC")) {
	    name = "IC " + name.substring(2).trim();
	    dbvs_name = "IC" + name.substring(2).trim();
	} else {
	    name = "NGC " + name.substring(3).trim();
	    dbvs_name = "NGC" + name.substring(3).trim();
	}
	String type = st.nextToken();
	String RA = st.nextToken();
	String Decl = st.nextToken();
	String size = st.nextToken();
	String mag = st.nextToken();
	String alias = "";
	if (st.hasMoreTokens()) {
	    alias = name;
	    name = st.nextToken();
	    dbvs_name = name;
	}

	record = name + "  ";
	if (alias.length() > 0)
	    record += alias + "  ";
	if (! type.equals("-"))
	    record += "(" + type + ")  ";
	record += "R.A.=" + RA.substring(0,2) + "h" + RA.substring(2,6) + "m  Decl.=" + Decl.substring(0,3) + "o" + Decl.substring(3,5) + "'";
	if (! size.equals("-"))
	    record += "  size=" + size + "'";
	if (! mag.equals("-"))
	    record += "  mag=" + mag;

	CoorMapping coor = new CoorMapping(Integer.parseInt(RA.substring(0,2)), Integer.parseInt(RA.substring(2,4)), ((double)Integer.parseInt(RA.substring(5,6))) / 10.0 * 60.0, (Decl.charAt(0) == '-'), Integer.parseInt(Decl.substring(1,3)), Integer.parseInt(Decl.substring(3,5)), 0.0);

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
