/*
 * Rotse.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
ROTSE1 J173357.54+535733.2 lpv  263.489777 +53.959240 10.36 0.002 0.00000000 0.00000000 0.318 5
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Rotse extends ReferenceCatalog {
    public Rotse ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 95)
	    return null;

	String name = record.substring(0, 26);
	String dbvs_name = name.replace(' ', '_');
	String type = record.substring(27, 32).trim();
	String RA = record.substring(8, 17);
	String Decl = record.substring(17, 26);
	String mag = record.substring(54, 59);
	String dmag = record.substring(88, 93);

	CoorMapping coor = new CoorMapping(Coor.createCoor(RA + " " + Decl));

	record = name + "  " + RA + " " + Decl + "  " + mag + " (" + dmag + ")  " + type;

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
