/*
 * TmzV.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
<Code    Con    R.A.  (J2000.0) Decl.     Max    Min  Type  Period    Epoch
---------------------------------------------------------------------------
TmzV01  Leo  10h39m37s.55 +12o23'22".2  10.5   12.2p   SR     150:        -
TmzV02  Vul  20h59m36s.85 +26o28'34".2  10.3   13.0p    M:      -         -
 *
 */

package misao.ref.catalog;

import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class TmzV extends ReferenceCatalog {
    public TmzV ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (! record.substring(0, 3).equals("Tmz"))
	    return null;

	String name = record.substring(0, 7).trim();
	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Integer.parseInt(record.substring(13,15)), Integer.parseInt(record.substring(16,18)), (double)Integer.parseInt(record.substring(19, 21)) + (double)Integer.parseInt(record.substring(23, 25).replace(' ','0')) / 100.0, (record.charAt(26) == '-'), Integer.parseInt(record.substring(27,29)), Integer.parseInt(record.substring(30,32)), (double)Integer.parseInt(record.substring(33, 35)) + (double)Integer.parseInt(record.substring(37,38).replace(' ','0')) / 10.0);

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
