/*
 * Veron.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
 *MS 23574-3520       0  0  2.8 -35  3 33 O         1521              0.508       17.6              -24.9  937      1521  23 57 28.8 -35 20 15
                      8 16  4.3 - 7 35 57     0.061  581              0.040 BL    16.1              -20.8           1184   8 13 37.9 - 7 26 41
 *Q 2357-005A           0  0 12.7 - 0 14 34      *2.83   Q    18.0                 1853      1853    G  1596  23 57 38.9 - 0 31 16
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Veron extends ReferenceCatalog {
    private Hashtable hash;

    public Veron ( ) {
	hash = new Hashtable();
    }

    public ReferenceData createReferenceData ( String record ) {
	String name = record.substring(2,19).trim();
	String dbvs_name = "";
	for (int i = 0 ; i < name.length() ; i++) {
	    if (name.charAt(i) != ' ')
		dbvs_name += name.charAt(i);
	}
	dbvs_name = dbvs_name.toUpperCase();

	CoorMapping coor = null;
	if (record.length() == 142) {
	    coor = new CoorMapping(Integer.parseInt(record.substring(21,23).trim()), Integer.parseInt(record.substring(24,26).trim()), (double)Float.valueOf(record.substring(27,31).trim()).floatValue(), (record.charAt(32) == '-'), Integer.parseInt(record.substring(33,35).trim()), Integer.parseInt(record.substring(36,38).trim()), (double)Integer.parseInt(record.substring(39,41).trim()));

	    if (name.length() == 0) {
		name = record.substring(122).replace(' ', '0');
		name = name.substring(0,2) + name.substring(3,5) + (name.charAt(11) == '-' ? '-' : '+') + name.substring(12,14) + name.substring(15,17);
		dbvs_name = "QSO" + name;
		name = "QSO " + name;
	    }
	} else if (record.length() == 130) {
	    coor = new CoorMapping(Integer.parseInt(record.substring(23,25).trim()), Integer.parseInt(record.substring(26,28).trim()), (double)Float.valueOf(record.substring(29,33).trim()).floatValue(), (record.charAt(34) == '-'), Integer.parseInt(record.substring(35,37).trim()), Integer.parseInt(record.substring(38,40).trim()), (double)Integer.parseInt(record.substring(41,43).trim()));

	    if (name.length() == 0) {
		name = record.substring(110).replace(' ', '0');
		name = name.substring(0,2) + name.substring(3,5) + (name.charAt(11) == '-' ? '-' : '+') + name.substring(12,14) + name.substring(15,17);
		dbvs_name = "QSO" + name;
		name = "QSO " + name;
	    }
	}

	boolean flag = true;
	for (int i = 0 ; i < dbvs_name.length() - 1 ; i++) {
	    if (! (('0' <= dbvs_name.charAt(i)  &&  dbvs_name.charAt(i) <= '9')  ||
		dbvs_name.charAt(i) == '+'  ||  dbvs_name.charAt(i) == '-'  ||  dbvs_name.charAt(i) == '.'))
		flag = false;
	}
	if (flag) {
	    name = "QSO " + name;
	    dbvs_name = "QSO" + dbvs_name;
	}

	if (dbvs_name.length() >= 4) {
	    flag = true;
	    for (int i = 0 ; i < 4 ; i++) {
		if (! ('0' <= dbvs_name.charAt(i)  &&  dbvs_name.charAt(i) <= '9'))
		    flag = false;
	    }
	    if (flag) {
		name = "QSO " + name;
		dbvs_name = "QSO" + dbvs_name;
	    }
	}

	int p = checkDuplication(dbvs_name);
	if (p > 0) {
	    name += "(" + p + ")";
	    dbvs_name += "(" + p + ")";
	}

	String s = name;
	if (record.length() == 142) {
	    s += "  R.A.=" + record.substring(21,23).replace(' ','0') + " " + record.substring(24,26).replace(' ','0') + " " + record.substring(27,31).replace(' ','0') + "  Decl.=" + (record.charAt(32) == '-' ? '-' : '+') + record.substring(33,35).replace(' ','0') + " " + record.substring(36,38).replace(' ','0') + " " + record.substring(39,41).replace(' ','0');
	    String mag = record.substring(82,87).trim();
	    if (mag.length() > 0)
		s += "  " + mag + " mag";
	    if (record.charAt(81) != ' ') {
		if (record.charAt(81) == '*')
		    s += " (p)";
		else
		    s += " (" + record.charAt(81) + ")";
	    }
	    mag = record.substring(88,93).trim();
	    if (mag.length() > 0)
		s += "  B-V=" + mag;
	    mag = record.substring(94,99).trim();
	    if (mag.length() > 0)
		s += "  U-B=" + mag;
	    String sp = record.substring(76,80).trim();
	    if (sp.length() > 0)
		s += "  class:" + sp;
	} else if (record.length() == 130) {
	    s += "  R.A.=" + record.substring(23,25).replace(' ','0') + " " + record.substring(26,28).replace(' ','0') + " " + record.substring(29,33).replace(' ','0') + "  Decl.=" + (record.charAt(34) == '-' ? '-' : '+') + record.substring(35,37).replace(' ','0') + " " + record.substring(38,40).replace(' ','0') + " " + record.substring(41,43).replace(' ','0');
	    String mag = record.substring(62,67).trim();
	    if (mag.length() > 0)
		s += "  " + mag + " mag";
	    if (record.charAt(61) != ' ') {
		if (record.charAt(61) == '*')
		    s += " (p)";
		else
		    s += " (" + record.charAt(61) + ")";
	    }
	    mag = record.substring(69,74).trim();
	    if (mag.length() > 0)
		s += "  B-V=" + mag;
	    mag = record.substring(76,81).trim();
	    if (mag.length() > 0)
		s += "  U-B=" + mag;
	    String sp = record.substring(57,59).trim();
	    if (sp.length() > 0)
		s += "  class:" + sp;
	}

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, s);

	return data;
    }

    private int countupDuplication ( String s ) {
	int count = 1;
	if (hash.containsKey(s)) {
	    count = ((Integer)hash.get(s)).intValue() + 1;
	    hash.remove(s);
	}
	hash.put(s, new Integer(count));
	return count;
    }

    private int checkDuplication ( String s ) {
	if (s.equals("4C17.22"))
	    return countupDuplication(s);
	if (s.equals("AH3"))
	    return countupDuplication(s);
	if (s.equals("AO0235+164"))
	    return countupDuplication(s);
	if (s.equals("B31523+421"))
	    return countupDuplication(s);
	if (s.equals("ESO428-G14"))
	    return countupDuplication(s);
	if (s.equals("H1400#12"))
	    return countupDuplication(s);
	if (s.equals("PKS0837+035"))
	    return countupDuplication(s);
	if (s.equals("PKS1144-379"))
	    return countupDuplication(s);
	if (s.equals("PKS1256-229"))
	    return countupDuplication(s);
	if (s.equals("Q0037-3327"))
	    return countupDuplication(s);
	if (s.equals("Q0039-4013"))
	    return countupDuplication(s);
	if (s.equals("Q0039-4022"))
	    return countupDuplication(s);
	if (s.equals("Q0040-3400"))
	    return countupDuplication(s);
	if (s.equals("Q0041-2904"))
	    return countupDuplication(s);
	if (s.equals("Q0042-2750"))
	    return countupDuplication(s);
	if (s.equals("Q0049-2535"))
	    return countupDuplication(s);
	if (s.equals("Q0049-3805"))
	    return countupDuplication(s);
	if (s.equals("Q0049-3843"))
	    return countupDuplication(s);
	if (s.equals("Q0049-4041"))
	    return countupDuplication(s);
	if (s.equals("Q0050-4143"))
	    return countupDuplication(s);
	if (s.equals("Q0052-3108"))
	    return countupDuplication(s);
	if (s.equals("Q0052-3901"))
	    return countupDuplication(s);
	if (s.equals("Q0052-4009"))
	    return countupDuplication(s);
	if (s.equals("Q0053-2813"))
	    return countupDuplication(s);
	if (s.equals("Q0053-3342"))
	    return countupDuplication(s);
	if (s.equals("Q0054-3101"))
	    return countupDuplication(s);
	if (s.equals("Q0054-4157"))
	    return countupDuplication(s);
	if (s.equals("Q0055-4214"))
	    return countupDuplication(s);
	if (s.equals("Q0056-3557"))
	    return countupDuplication(s);
	if (s.equals("Q0059-3911"))
	    return countupDuplication(s);
	if (s.equals("Q0101-3630"))
	    return countupDuplication(s);
	if (s.equals("Q0102-4002"))
	    return countupDuplication(s);
	if (s.equals("Q0103-4032"))
	    return countupDuplication(s);
	if (s.equals("Q0105-4005"))
	    return countupDuplication(s);
	if (s.equals("Q0121-3855"))
	    return countupDuplication(s);
	if (s.equals("Q0128-3913"))
	    return countupDuplication(s);
	if (s.equals("Q0128-4225"))
	    return countupDuplication(s);
	if (s.equals("Q0133-4009"))
	    return countupDuplication(s);
	if (s.equals("Q0134-4202"))
	    return countupDuplication(s);
	if (s.equals("Q0136-3831"))
	    return countupDuplication(s);
	if (s.equals("Q0136-3847"))
	    return countupDuplication(s);
	if (s.equals("Q0137-4202"))
	    return countupDuplication(s);
	if (s.equals("Q0144-4042"))
	    return countupDuplication(s);
	if (s.equals("Q0145-3835"))
	    return countupDuplication(s);
	if (s.equals("Q0152-3812"))
	    return countupDuplication(s);
	if (s.equals("Q0152-4055"))
	    return countupDuplication(s);
	if (s.equals("Q0155-3939"))
	    return countupDuplication(s);
	if (s.equals("Q0245+0023"))
	    return countupDuplication(s);
	if (s.equals("Q0250-0146"))
	    return countupDuplication(s);
	if (s.equals("Q1039+047"))
	    return countupDuplication(s);
	if (s.equals("Q1039+049"))
	    return countupDuplication(s);
	if (s.equals("Q1158-1054"))
	    return countupDuplication(s);
	if (s.equals("Q1216-1103"))
	    return countupDuplication(s);
	if (s.equals("Q1219-1113"))
	    return countupDuplication(s);
	if (s.equals("Q2119-4307"))
	    return countupDuplication(s);
	if (s.equals("Q2129-4653"))
	    return countupDuplication(s);
	if (s.equals("Q2131-4515"))
	    return countupDuplication(s);
	if (s.equals("Q2139-4332"))
	    return countupDuplication(s);
	if (s.equals("Q23552+1842"))
	    return countupDuplication(s);
	if (s.equals("QSO0149-510"))
	    return countupDuplication(s);
	if (s.equals("QSO1255+2748"))
	    return countupDuplication(s);
	if (s.equals("QSO1637.9+4045"))
	    return countupDuplication(s);
	if (s.equals("S41321+41"))
	    return countupDuplication(s);

	return 0;
    }
}
