/*
 * CatalogData.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class CatalogData extends StarData {
    private String id;
    private String record;

    public CatalogData ( ) {
	super();
    }

    public CatalogData ( StarData sd ) {
	super(sd);

	if (sd instanceof CatalogData) {
	    CatalogData data = (CatalogData)sd;
	    id = data.id;
	    record = data.record;
	}
    }

    public String getID ( ) {
	return id;
    }

    public String getRecord ( ) {
	return record;
    }

    public void setID ( String s ) {
	id = s;
    }

    public void setRecord ( String s ) {
	record = s;
    }

    public static CatalogData createCatalogData ( String s ) {
	CatalogIndex catalog_index = new CatalogIndex();
	Catalog catalog = catalog_index.getFirstStarCatalog();
	while (catalog != null) {
	    CatalogList list = catalog.createCatalogList();
	    CatalogData data = list.createCatalogData(s);
	    if (data != null)
		return data;

	    catalog = catalog_index.getNextStarCatalog();
	}

	return null;
    }
}
