/*
 * CgiList.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.net.*;
import java.io.*;

public abstract class CgiList extends CatalogList {
    private String urlCGI;
    private DataInputStream dis;

    public abstract void load ( Coor center_coor, double fov, double mag ) throws Exception;

    public void openConnectionGet ( String url_cgi ) throws Exception {
	URL url;
	URLConnection uc;

	urlCGI = url_cgi;

	try {
	    url = new URL(urlCGI);
	} catch ( MalformedURLException e ) {
	    System.err.println("Malformed URL: " + urlCGI);
	    throw e;
	}

	try {
	    uc = url.openConnection();
	} catch ( IOException e ) {
	    System.err.println("Cannot connect to: " + urlCGI);
	    throw e;
	}

	InputStream is = uc.getInputStream();
	dis = new DataInputStream(is);
    }

    public void openConnectionPost ( String url_cgi, String argument ) throws Exception {
	URL url;
	URLConnection uc;

	urlCGI = url_cgi;

	try {
	    url = new URL(urlCGI);
	} catch ( MalformedURLException e ) {
	    System.err.println("Malformed URL: " + urlCGI);
	    throw e;
	}

	try {
	    uc = url.openConnection();
	} catch ( IOException e ) {
	    System.err.println("Cannot connect to: " + urlCGI);
	    throw e;
	}

	uc.setDoOutput(true);

	try {
	    OutputStream os = uc.getOutputStream();
	    PrintStream ps = new PrintStream(os);
	    ps.print(argument);
	    ps.close();
	} catch ( IOException e ) {
	    System.err.println("Cannot write to: " + urlCGI);
	    throw e;
	}

	InputStream is = uc.getInputStream();
	dis = new DataInputStream(is);
    }

    public String readLine ( ) throws IOException {
	try {
	    return dis.readLine();
	} catch ( IOException e ) {
	    System.err.println("Cannot read data: " + urlCGI);
	    throw e;
	}
    }

    public void close ( ) throws IOException {
	try {
	    dis.close();
	} catch ( IOException e ) {
	    System.err.println("Cannot close connection to: " + urlCGI);
	    throw e;
	}
    }
}
