/*
 * CoorMapping.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class CoorMapping extends Coor {
    public CoorMapping ( ) {
	super();
    }

    public CoorMapping ( double ra, double decl ) {
	super(ra, decl);
    }

    public CoorMapping ( Coor coor ) {
	super(coor);
    }

    // (x,y) -> R.A., Decl.
    public CoorMapping ( Coor center_coor, Position pos ) {
	double x = pos.getX();
	double y = pos.getY();

	double rad = Math.sqrt(x * x + y * y);
	double theta = Math.atan2(y,x) / Astro.RAD + 90.0;
	if (theta > 360.0)
	    theta -= 360.0;

	double st = Math.sin(center_coor.getDecl() * Astro.RAD) * Math.cos(rad * Astro.RAD) + Math.cos(center_coor.getDecl() * Astro.RAD) * Math.sin(rad * Astro.RAD) * Math.cos(theta * Astro.RAD);
	double d = Math.atan2(st, Math.sqrt(1 - st * st)) / Astro.RAD;
	double a = 0.0;
	if (Math.cos(d * Astro.RAD) != 0.0) {
	    st = Math.sin(theta * Astro.RAD) * Math.sin(rad * Astro.RAD) / Math.cos(d * Astro.RAD);
	    a = center_coor.getRA() - Math.atan2(st, Math.sqrt(1 - st * st)) / Astro.RAD;
	    if (a >= 360.0)
		a -= 360.0;
	    if (a < 0.0)
		a += 360.0;
	}

	setRA(a);
	setDecl(d);
    }

    public CoorMapping ( int ra_h, int ra_m, double ra_s, boolean south_flag, int decl_d, int decl_m, double decl_s ) {
	super(ra_h, ra_m, ra_s, south_flag, decl_d, decl_m, decl_s);
    }

    // R.A., Decl. -> (x,y)
    public Position mappingXY ( Coor center_coor ) {
	double rad = center_coor.angular_distance(this);
	double theta = center_coor.direction(this);

	// positive direction is to the left and down on chart
	Position pos = new Position(- rad * Math.sin(theta * Astro.RAD), - rad * Math.cos(theta * Astro.RAD));
	return pos;
    }
}
