/*
 * ImageFileGif.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.io.*;
import java.net.*;
import java.awt.*;
import sun.awt.image.URLImageSource;

public class ImageFileGif extends ImageRGB {
    public ImageFileGif ( URL url ) throws Exception {
	super(new ImageRGB(Toolkit.getDefaultToolkit().createImage(new URLImageSource(url)), getSize(url)));
    }

    public static Size getSize ( URL url ) throws Exception {
	URLConnection uc;
	try {
	    uc = url.openConnection();
	} catch ( IOException e ) {
	    System.err.println("Cannot connect to: " + url.toString());
	    throw e;
	}

	uc.connect();

	DataInputStream dis = null;
	try {
	    InputStream is = uc.getInputStream();
	    dis = new DataInputStream(new BufferedInputStream(is));
	} catch ( IOException e ) {
	    System.err.println("Cannot read from: " + url.toString());
	}

	for (int i = 0 ; i < 6 ; i++)
	    dis.read();
	int w = (dis.read() | (dis.read() << 8));
	int h = (dis.read() | (dis.read() << 8));

	dis.close();

	return new Size(w, h);
    }
}
