/*
 * ImageFileJpeg.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.io.*;
import java.net.*;
import java.awt.*;
import sun.awt.image.URLImageSource;

public class ImageFileJpeg extends ImageRGB {
    public ImageFileJpeg ( URL url ) throws Exception {
	super(new ImageRGB(Toolkit.getDefaultToolkit().createImage(new URLImageSource(url)), getSize(url)));
    }

    public static Size getSize ( URL url ) throws Exception {
	URLConnection uc;
	try {
	    uc = url.openConnection();
	} catch ( IOException e ) {
	    System.err.println("Cannot connect to: " + url.toString());
	    throw e;
	}

	uc.connect();

	DataInputStream dis = null;
	try {
	    InputStream is = uc.getInputStream();
	    dis = new DataInputStream(new BufferedInputStream(is));
	} catch ( IOException e ) {
	    System.err.println("Cannot read from: " + url.toString());
	}

	for (int i = 0 ; i < 2 ; i++)
	    dis.read();

	int w = 0;
	int h = 0;

	boolean flag = true;
	while (flag) {
	    int ch = dis.read();
	    if (ch == 255) {
		ch = dis.read();
		if (192 <= ch  &&  ch <= 207  &&  (ch != 196  &&  ch != 200  &&  ch != 204)) {
		    for (int i = 0 ; i < 3 ; i++)
			dis.read();
		    h = ((dis.read() << 8) | dis.read());
		    w = ((dis.read() << 8) | dis.read());
		    flag = false;
		} else if (ch == 217  ||  ch == 218) {
		    dis.close();
		    throw new Exception();
		} else {
		    int l = ((dis.read() << 8) | dis.read());
		    for (int i = 0 ; i < l - 2 ; i++)
			dis.read();
		}
	    }
	}

	dis.close();

	return new Size(w, h);
    }
}
