/*
 * StarData.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.awt.Color;

public class StarData {
    private Position pos;
    private Coor coor;
    private double mag;

    private Color color;
    private boolean circle;

    private StarData contain;

    private StarData current_appendix;

    public StarData ( ) {
	pos = new Position();
	coor = new Coor();
	mag = 99.9;
	color = null;
	circle = false;

	contain = null;
    }

    public StarData ( StarData sd ) {
	pos = new Position(sd.getPosition());
	coor = new Coor(sd.getCoor());
	mag = sd.mag;
	color = sd.color;
	circle = sd.circle;

	contain = null;
	if (sd.contain != null) {
	    contain = new StarData(sd.contain);
	}
    }

    public double getX ( ) {
	return pos.getX();
    }

    public double getY ( ) {
	return pos.getY();
    }

    public Position getPosition ( ) {
	return pos;
    }

    public Coor getCoor ( ) {
	return coor;
    }

    public double getMag ( ) {
	return mag;
    }

    public void setX ( double x ) {
	pos.setX(x);
    }

    public void setY ( double y ) {
	pos.setY(y);
    }

    public void setPosition ( Position Pos ) {
	pos.set(Pos);
    }

    public void setCoor ( Coor cr ) {
	coor = cr;
    }

    public void setMag ( double Mag ) {
	mag = Mag;
    }

    // add dx, dy to x, y
    public void shiftXY ( Position d_xy ) {
	pos.add(d_xy);

	if (contain != null)
	    contain.shiftXY(d_xy);
    }

    // mutiply x, y by w
    public void rescaleXY ( double w ) {
	pos.rescale(w);

	if (contain != null)
	    contain.rescaleXY(w);
    }

    public void append ( StarData sd ) {
	StarData sd_last = this;
	StarData sd_tmp = getFirstAppendix();
	while (sd_tmp != null) {
	    sd_last = sd_tmp;
	    sd_tmp = getNextAppendix();
	}
	sd_last.contain = sd;
    }

    public void removeAppendix ( StarData sd ) {
	StarData sd_tmp = getFirstAppendix();
	StarData sd_prev = this;
	while (sd_tmp != null) {
	    StarData sd_tmp2 = sd_tmp;
	    sd_tmp = getNextAppendix();

	    if (sd_tmp2 == sd)
		sd_prev.contain = sd_tmp;
	    else
		sd_prev = sd_tmp2;
	}
    }

    public StarData getFirstAppendix ( ) {
	current_appendix = contain;
	return current_appendix;
    }

    public StarData getNextAppendix ( ) {
	if (current_appendix != null)
	    current_appendix = current_appendix.contain;
	return current_appendix;
    }

    public void setColor ( Color c ) {
	color = c;
    }

    public void setColorAll ( Color c ) {
	color = c;
	if (contain != null)
	    contain.setColorAll(color);
   }

    public Color getColor ( ) {
	return color;
    }

    public void setPlotDefault ( ) {
	circle = false;
    }

    public void setPlotCircle ( ) {
	circle = true;
    }

    public void setPlotDefaultAll ( ) {
	circle = false;
	if (contain != null)
	    contain.setPlotDefaultAll();
    }

    public void setPlotCircleAll ( ) {
	circle = true;
	if (contain != null)
	    contain.setPlotCircleAll();
    }

    public boolean isCircle ( ) {
	return circle;
    }

    public String getRecord ( ) {
	return toString();
    }

    public String toString ( ) {
	return pos.toString() + " " + coor.toString() + " " + mag;
    }
}
